﻿//
// GrabschCamView
//   ASkr 2009-2010; www.askrprojects.net
//   Published under the LMAA-license (German ;-)
//

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
  // needed for DebugAcq arguments...
  //  public partial class formCam : Form
  partial class formCam : Form
  {

    formMain fMainWin = null;

    // ugly...
    private Bitmap flag;
    private Graphics flagGraphics;
    private byte[] rgbValues;
    private int bytes;
    private IntPtr ptr;


    public formCam(formMain fMain)
    {
      fMainWin = fMain;
      InitializeComponent();
      InitView(188,144);
    }


    //************************************************************************
    //*** InitView()
    //***
    //*** x,y -> size of bitmap (true color)
    //************************************************************************
    public void InitView(int x, int y)
    {
      flag = new Bitmap(x, y);
      flagGraphics = Graphics.FromImage(flag);
      picCamView.Image = flag;

      Rectangle rect = new Rectangle(0, 0, flag.Width, flag.Height);
      System.Drawing.Imaging.BitmapData bmpData =
          flag.LockBits(rect, System.Drawing.Imaging.ImageLockMode.ReadWrite,
          flag.PixelFormat);

      ptr = bmpData.Scan0;

      bytes = bmpData.Stride * flag.Height;
      rgbValues = new byte[bytes];

      System.Runtime.InteropServices.Marshal.Copy(ptr, rgbValues, 0, bytes);

      for (int counter = 0; counter < rgbValues.Length; counter += 1)
        rgbValues[counter] = (byte)counter;

      System.Runtime.InteropServices.Marshal.Copy(rgbValues, 0, ptr, bytes);

      flag.UnlockBits(bmpData);
      flagGraphics.FillRectangle(Brushes.DarkBlue, 0, 0, flag.Width, flag.Height);
      flagGraphics.DrawEllipse(Pens.Black, x/2-x/20, y/2-y/20, x/10, y/10);

      picCamView.Refresh();

    }


    public void ShowCam(DebugAcq pAcq, int Addr, int Len)
    {
      int j;

      for (int counter = 0; counter < rgbValues.Length-4; counter += 4)
      {
        try{j=pAcq.varData[counter >> 2];}
        catch{break;}

        rgbValues[counter+0] = (byte)(j&0xfe);   // blue
        rgbValues[counter+1] = (byte)(j&0xfe);   // green
        rgbValues[counter+2] = (byte)(j&0xfe);   // red
        rgbValues[counter+3] = 255;         // alpha 
      }
      System.Runtime.InteropServices.Marshal.Copy(rgbValues, 0, ptr, bytes);
      picCamView.Refresh();

    }





    private void picCamView_Click(object sender, EventArgs e)
    {
      if(picCamView.SizeMode==PictureBoxSizeMode.Zoom)
        picCamView.SizeMode=PictureBoxSizeMode.StretchImage;
      else
        picCamView.SizeMode=PictureBoxSizeMode.Zoom;

    }



  }
}
