﻿//
// GrabschCamView
//   ASkr 2009-2010; www.askrprojects.net
//   Published under the LMAA-license (German ;-)
//

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


namespace WindowsFormsApplication1
{

  class DebugAcq
  {

    //--------------------------------------------------------------------------------------------------------
    //-PRIVATE------------------------------------------------------------------------------------------------
    
    // packet input (0x10,0x02,...data...,0x10,0x03)
    // The complete buffer is discarded on a single error!
    // Only if a complete, error-free packet was received, it's slammed into "varData"
    private System.Collections.Generic.List<int> inpData = new System.Collections.Generic.List<int>();
    private int inpDataState=0;
    

    // This from where the variables of "DebugVar" will read out their contents.
    // The contents of this array will be valid until a new packet is received successfully.
    public int[] varData=null;


    private void FlushInputData()
    {
      inpDataState=0;
      inpData.Clear();
    }

    private void StoreInputData()
    {
      // we trust in the garbage collector ;)

      // TODO
      // possibly: try, catch...
      varData=new int[inpData.Count()];
      inpData.CopyTo(varData);
    }

    //--------------------------------------------------------------------------------------------------------
    //-PUBLIC-------------------------------------------------------------------------------------------------

    public int AddData(int data)
    {
      if(data <0)
      {
        FlushInputData();
        return 0;
      }

      switch(inpDataState)
      {
        // waiting for initial "0x10"
        case 0:
          if(data!=0x10)
            break;
          inpDataState++;
          break;

        // waiting for "0x02"
        case 1:
          if(data!=0x02)
          {
            FlushInputData();
            break;;
          }
          inpDataState++;
          break;

        // store data and remain in this state (if not 0x10!)
        case 2:
          if(data!=0x10)
          {
            inpData.Add(data);
            break;
          }
          else
          {
            inpDataState++;
            break;
          }

        // on 0x10         -> store data and back to state 2
        // on 0x03         -> end of packet detected
        // everything else -> error
        case 3:
          switch(data)
          {
            case 0x10:
              inpData.Add(data);
              inpDataState--;
              break;
            case 0x03:
              StoreInputData();
              FlushInputData();
              return 1;                //     <========== RETURN OK!
            default:
              FlushInputData();
              break;
          }// END switch case 3
          break;

        // this should never happen...
        default:
          FlushInputData();
          break;
      }//END switch

      return 0;
    }




  }
}
