﻿//
// GrabschCamView
//   ASkr 2009-2010; www.askrprojects.net
//   Published under the LMAA-license (German ;-)
//

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WindowsFormsApplication1
{
  class DebugVar
  {

    private DebugAcq pAcq;
    private formCam fCam;
    private string Name;
    private int Addr;
    private int Len;
    private int ViewAs;
    private bool Signed;
    private bool On;
    private int dgViewRow;
    /* ViewAS:
          0 dec
          1 hex
          2 bin
          3 oct
          4 char
          5 float
         10 video
    */

    public DebugVar(DebugAcq pAcq, formCam fCam, string Name, int Addr, int Len, int ViewAs, bool Signed, bool On, int dgViewRow)
    {
      this.pAcq=pAcq;
      this.fCam=fCam;
      this.Name=Name;
      this.Addr = Addr;
      this.Len=Len;
      this.ViewAs=ViewAs;
      this.Signed=Signed;
      this.On=On;
      this.dgViewRow=dgViewRow;
    }


    public int getRow()
    {
      return this.dgViewRow;
    }


    public string getAsString()
    {
      uint val=0;
      string sout="";

      if(this.On==false)
        return "not on";
      if(this.Len<1)
        return "length error";
      if((this.Len>4)&&(this.ViewAs!=10))
        return "length error";

      if(this.ViewAs!=10)
      {
        for(int i=0;i<Len;i++)
        {
          try
          {
            val+=(uint)((pAcq.varData[Addr+i]&0xff)<<(8*i));
          }
          catch{val=0;}
        }

        switch(this.ViewAs)
        {
          case  0: sout=Convert.ToString(val); break;
          case  1: sout=Convert.ToString(val,16) ; break;
          case  2: sout=Convert.ToString(val,2) ; break;
          case  3: sout=Convert.ToString(val,8) ; break;
          case  4: sout="no chars yet"; break;
          case  5: sout="no floats yet"; break;
        }// END switch ViewAs
        return sout;
      }// END if not video
      else
      {
        fCam.ShowCam(this.pAcq,this.Addr,this.Len);
        return "CamView";
      }

    }



    public String getDbgString()
    {
      string sout="";

      if(this.On==true)
        sout+="On  ";
      else
        sout+="Off ";
      
      sout+=this.Name + " ";

      if(this.Signed==true)
        sout+="Signed   ";
      else
        sout+="Unsigned ";

      try{sout+=Convert.ToString(ViewAs)+" ";}
      catch{sout+="error ";}

      try{sout+="A:"+Convert.ToString(Addr)+" ";}
      catch{sout+="A:ERR ";}

      try{sout+="L:"+Convert.ToString(Len)+" ";}
      catch{sout+="A:ERR ";}

      return sout;
    }


  }
}
