﻿//
// GrabschCamView
//   ASkr 2009-2010; www.askrprojects.net
//   Published under the LMAA-license (German ;-)
//

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Xml.Serialization;
using System.IO;

using System.Runtime.Serialization.Formatters.Binary;





namespace WindowsFormsApplication1 // ;-))
{
  public partial class formMain : Form
  {

    public System.IO.Ports.SerialPort expSerialPort;

    private formCam fCam = null;
    private formRaw fRaw = null;
    private System.Collections.Generic.List<DebugVar> lVars = new System.Collections.Generic.List<DebugVar>();
    private DebugAcq dAcq;


    public formMain()
    {
      CheckForIllegalCrossThreadCalls=false;

      // not that nice, but sufficient for HW guys ;)
      dAcq = new DebugAcq();
      fRaw = new formRaw(this);
      fCam = new formCam(this);

      InitializeComponent();
      expSerialPort = serialPort1;
      butSerClose.Enabled = false;
    }


    private void dataGridView1_CellContentClick(object sender, DataGridViewCellEventArgs e)
    {

    }

    private void label1_Click(object sender, EventArgs e)
    {

    }

    private void label2_Click(object sender, EventArgs e)
    {

    }

    private void cmbSerPort_Enter(object sender, EventArgs e)
    {
      string[] AvailableCOMPorts;
      this.cmbSerPort.Items.Clear();
      this.cmbSerPort.Text = "";
      AvailableCOMPorts = System.IO.Ports.SerialPort.GetPortNames();
      for (int j = 0; j < AvailableCOMPorts.Length; j++)
        this.cmbSerPort.Items.Add(AvailableCOMPorts[j]);
    }

    private void butSerOpen_Click(object sender, EventArgs e)
    {

      if (this.cmbSerPort.Text.CompareTo(System.String.Empty) != 0)
      {
        int i;
        serialPort1.PortName = this.cmbSerPort.Text;
        if ((i=Convert.ToInt32(cmbSerRate.Text))==0)
          return;

        serialPort1.BaudRate = i;
        serialPort1.DataBits = 8;
        serialPort1.StopBits = System.IO.Ports.StopBits.One;
        serialPort1.Parity = System.IO.Ports.Parity.None;
        serialPort1.Handshake = System.IO.Ports.Handshake.None;

        try
        {
          serialPort1.Open();
        }

        catch (System.Exception)
        {
          MessageBox.Show("Unable to open selected port.\n(" + ")");
        }
        finally
        {
          if (serialPort1.IsOpen)
          {
            serialPort1.RtsEnable = true;
            serialPort1.DtrEnable = true;
            serialPort1.WriteTimeout = 5000;
            butSerOpen.Enabled = false;
            cmbSerPort.Enabled = false;
            butSerClose.Enabled = true;
            cmbSerRate.Enabled = false;

          }// ebd if port open
        }// end finally
      }//end if port string !empty
    }

    private void butSerClose_Click(object sender, EventArgs e)
    {
      try
      {
        serialPort1.Close();
      }
      catch (System.Exception)
      {
        MessageBox.Show("Ups... Unable to close port.");
      }

      butSerOpen.Enabled = true;
      cmbSerPort.Enabled = true;
      butSerClose.Enabled = false;
      cmbSerRate.Enabled = true;
    }

    private void butViewRaw_Click(object sender, EventArgs e)
    {
      if (fRaw.Visible)
        fRaw.Hide();
      else
        fRaw.Show();

    }

    private void butViewCam_Click(object sender, EventArgs e)
    {
      if (fCam.Visible)
        fCam.Hide();
      else
        fCam.Show();
    }

    private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
    {
      int n=serialPort1.BytesToRead;

      // DEBUG
      // This does not work because fRaw operates in another thread!
      // 
      //      fRaw.AddLine("r");

      for(int i=0;i<n;i++)
      {
        try
        {
          if(dAcq.AddData(serialPort1.ReadByte())!=0)
            dgView_UpdateVarValues();
        }
        catch{break;}
      }
    }


    
    public void dgView_UpdateAll()
    {
      datGridView.Rows.Clear();
    }




    public void dgView_UpdateVarValues()
    {
      if(lVars != null)
      {
        try
        {
          foreach(DebugVar j in lVars)
          {
//            fRaw.AddLine(j.getDbgString()+Environment.NewLine);
            datGridView.Rows[j.getRow()].Cells[2].Value=j.getAsString();
          }// END foreach variable
        }
        catch   {; }
      }

    }


    private void dgView_Analyze()
    {
      // This sucks... I don't even want to talk about it ;)

      // DEBUG
      fRaw.AddLine("A");

      lVars.Clear();

      if(datGridView.Rows != null)
      {
        for(int row=0;row<datGridView.Rows.Count-1;row++)
        {

          bool cOn=false;
          string cName="";
          bool cSigned=false;
          int cView=0;
          int cAddr=0;
          int cLen=0;

          for(int col=0;col<7;col++)
          {
            // skip the value cell
            if(col==2)
              continue;

            string tmp;
            try
            {
              tmp=datGridView.Rows[row].Cells[col].FormattedValue.ToString();
              tmp=datGridView.Rows[row].Cells[col].EditedFormattedValue.ToString();
            }
            catch{tmp="";}

            switch(col)
            {
              // bool "On"
              case 0:
                if(tmp=="True") cOn=true; break;

              // string "Variable"
              case 1:
                cName=tmp; break;

              // bool "Signed"
              case 3:
                if(tmp=="True") cSigned=true; break;

              // int "ViewAs"
              case 4:
                if(tmp=="dec") cView=0;
                if(tmp=="hex") cView=1;
                if(tmp=="bin") cView=2;
                if(tmp=="oct") cView=3;
                if(tmp=="char") cView=4;
                if(tmp=="float") cView=5;
                if(tmp=="video") cView=10;
                break;

              // int "Addr"
              case 5:
                try{cAddr=Convert.ToInt32(tmp);}
                catch{;}
                break;

              // int "Len"
              case 6:
                try{cLen=Convert.ToInt32(tmp);}
                catch{;}
                break;
            }// END switch

          }// END for each col

          lVars.Add(new DebugVar(dAcq,fCam,cName,cAddr,cLen,cView,cSigned,cOn,row));

        }// END for every row
      }// END if anything in dgView
    }




    private void butSave_Click(object sender, EventArgs e)
    {
      string fName="";

      if(saveFileDialog1.ShowDialog()==DialogResult.OK)
      {
        fName=saveFileDialog1.FileName;
      }
      else
        return;


      List<string[]> sAllOut=new List<string[]>();
      string[] tmp=new string[5];

      // Start with saving:
      //   - COM Port
      //   - rate
      //   - pixelBits
      //   - xres
      //   - yres
      tmp[0]=cmbSerPort.Text;
      tmp[1]=cmbSerRate.Text;
      tmp[2]=txtPixelBits.Text;
      tmp[3]=txtXRes.Text;
      tmp[4]=txtYRes.Text;
      sAllOut.Add(tmp);

      // The rest of the array is slammed into the dataGridView.
      // 7 cells for every of the n rows...
      if(datGridView.Rows.Count>1)
      {
        for(int row=0;row<datGridView.Rows.Count-1;row++)
        {
          string[] sOut =new string[7];
          for(int col=0;col<7;col++)
          {
            try{sOut[col]=datGridView.Rows[row].Cells[col].Value.ToString();}
            catch{sOut[col]="";}
          }// END for every cell
          sAllOut.Add(sOut);
        }// END for every row
      }// END if rows > 1

      XmlSerializer serializer = new XmlSerializer(typeof(List<string[]>));
      FileStream fs;
      try
      { fs = new FileStream(fName, FileMode.Create); }
      catch(Exception bloed)
      {
        MessageBox.Show("Error opening file:" + Environment.NewLine + bloed.Message);
        return;
      }

      try{serializer.Serialize(fs, sAllOut);}
      catch{MessageBox.Show("Error parsing the DataGridView Element...");}
      fs.Close();
    }



    private void butLoad_Click(object sender, EventArgs e)
    {
      List<string[]> sAllIn = new List<string[]>();

      string fName="";

      if(openFileDialog1.ShowDialog()==DialogResult.OK)
      {
        fName=openFileDialog1.FileName;
      }
      else
        return;

      FileStream fs;
      XmlSerializer deserializer = new XmlSerializer(typeof(List<string[]>));
      try{fs = new FileStream(fName, FileMode.Open);}
      catch(Exception doof)
      {
        MessageBox.Show("Error opening file:" + Environment.NewLine + doof.Message);
        return;
      }
      try{sAllIn=(List<string[]>)deserializer.Deserialize(fs);}
      catch{MessageBox.Show("Error reading back the DataGridView contents...");}
      fs.Close();

      if(sAllIn.Count > 0)
      {
        cmbSerPort.Text=sAllIn[0][0];
        cmbSerRate.Text=sAllIn[0][1];
        txtPixelBits.Text=sAllIn[0][2];
        txtXRes.Text=sAllIn[0][3];
        txtYRes.Text=sAllIn[0][4];

        sAllIn.RemoveAt(0);

        if(sAllIn.Count >= 1)
        {
          datGridView.Rows.Clear();

          Object[] oRow = new Object[7];

          foreach(string[] srow in sAllIn)
          {
            for(int i=0;i<7;i++)
            {
              switch(i)
              {
                // switches "On" and "Signed"
                case 0:
                case 3:
                  if(srow[i]=="True")
                    oRow[i]=true;
                  else
                    oRow[i]=false;
                  break;

                // just copy strings for "Name", "ViewAs", "Addr" and "Len"
                case 1:
                case 4:
                case 5:
                case 6:
                  oRow[i]=srow[i];
                  break;


                // "Value"
                case 2:
                  oRow[i]="";
                  break;
                
              }// END switch
            }// END for all cells

            datGridView.Rows.Add(oRow);
          }// END foreach row

        }// END if rows > 1

        dgView_Analyze();

        butUpdate_Click(null,null);

      }// END if rows > 0
      

    }


    private void dgView_DataError(object sender, DataGridViewDataErrorEventArgs e)
    {
      // DEBUG ONLY
      int i;
      i=1;
    }




    private void dgView_EndEdit(object sender, DataGridViewCellEventArgs e)
    {
      dgView_Analyze();
    }

    private void dgView_RowsAdded(object sender, DataGridViewRowsAddedEventArgs e)
    {
      dgView_Analyze();
    }

    private void dgView_RowsDeleted(object sender, DataGridViewRowsRemovedEventArgs e)
    {
      dgView_Analyze();
    }

    private void dgView_MouseUp(object sender, DataGridViewCellMouseEventArgs e)
    {
      dgView_Analyze();
    }

    private void butUpdate_Click(object sender, EventArgs e)
    {
      int x,y;

      try  {x=Convert.ToInt32(txtXRes.Text);}
      catch{x=320;}
        
      try  {y=Convert.ToInt32(txtYRes.Text);}
      catch{y=200;}

      if(x<1)
        x=1;
      if(x>1024)
        x=1024;
      if(y<1)
        y=1;
      if(y>768)
        y=768;

      txtXRes.Text=x.ToString();
      txtYRes.Text=y.ToString();

      string tmp=txtPixelBits.Text;
      tmp.Trim();

      fCam.InitView(x,y);
    }

    private void formMain_Close(object sender, FormClosingEventArgs e)
    {
      butSerClose_Click(null,null);
    }

    private void cmbSerPort_SelectedIndexChanged(object sender, EventArgs e)
    {

    }



  }//end class
}// end namespace
